﻿package 
{
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.events.Event;
	import flash.geom.Matrix;
	import flash.geom.Transform;
	
	public class Main extends Sprite 
	{
		private var m_Shape : Shape;
		private var m_BoxShape : Shape;

		private var m_PosX : Number, m_PosY : Number;
		private const m_HalfSizeX : Number = 100, m_HalfSizeY : Number = 50;
		// In radians, advanced every frame.
		private var m_Orientation : Number = 0;
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			addEventListener(Event.ENTER_FRAME, OnEnterFrame);
			
			m_PosX = stage.stageWidth  * 0.5;
			m_PosY = stage.stageHeight * 0.5;
			
			// Transform of this shape is set every frame.
			m_Shape = new Shape();
			m_Shape.graphics.beginFill(0x00FF00);
			m_Shape.graphics.drawRect(0, 0, m_HalfSizeX*2, m_HalfSizeY*2);
			m_Shape.graphics.endFill();
			addChild(m_Shape);
			
			// Position of this shape stays (0,0).
			m_BoxShape = new Shape();
			addChild(m_BoxShape);
		}
		
		private function OnEnterFrame(e:Event):void
		{
			// m_Shape will be rectangle centered at (m_PosX, m_PosY).
			var transform : Transform = new Transform(m_Shape);
			var matrix : Matrix = new Matrix();
			matrix.translate(-m_HalfSizeX, -m_HalfSizeY);
			matrix.rotate(m_Orientation);
			matrix.translate(m_PosX, m_PosY);
			m_Shape.transform = transform;
			transform.matrix = matrix;
			
			// corner_1 is right-top corner of unrotated rectangle, relative to m_Pos.
			// corner_2 is right-bottom corner of unrotated rectangle, relative to m_Pos.
			var corner_1_x : Number = m_HalfSizeX;
			var corner_2_x : Number = m_HalfSizeX;
			var corner_1_y : Number = -m_HalfSizeY;
			var corner_2_y : Number =  m_HalfSizeY;
			
			var sin_o : Number = Math.sin(m_Orientation), cos_o : Number = Math.cos(m_Orientation);
			
			// xformed_corner_1, xformed_corner_2 are points corner_1, corner_2 rotated by angle m_Orientation.
			var xformed_corner_1_x : Number = corner_1_x * cos_o - corner_1_y * sin_o;
			var xformed_corner_1_y : Number = corner_1_x * sin_o + corner_1_y * cos_o;
			var xformed_corner_2_x : Number = corner_2_x * cos_o - corner_2_y * sin_o;
			var xformed_corner_2_y : Number = corner_2_x * sin_o + corner_2_y * cos_o;
			
			// ex, ey are extents (half-sizes) of the final AABB.
			var ex : Number = Math.max(Math.abs(xformed_corner_1_x), Math.abs(xformed_corner_2_x));
			var ey : Number = Math.max(Math.abs(xformed_corner_1_y), Math.abs(xformed_corner_2_y));

			var aabb_min_x : Number = m_PosX - ex;
			var aabb_max_x : Number = m_PosX + ex;
			var aabb_min_y : Number = m_PosY - ey;
			var aabb_max_y : Number = m_PosY + ey;
			
			m_BoxShape.graphics.clear();
            m_BoxShape.graphics.lineStyle(2, 0x000000);
			m_BoxShape.graphics.moveTo(aabb_min_x, aabb_min_y);
			m_BoxShape.graphics.lineTo(aabb_max_x, aabb_min_y);
			m_BoxShape.graphics.lineTo(aabb_max_x, aabb_max_y);
			m_BoxShape.graphics.lineTo(aabb_min_x, aabb_max_y);
			m_BoxShape.graphics.lineTo(aabb_min_x, aabb_min_y);

			m_Orientation += 0.05;
		}
	}
	
}